--- /wrk/src/linux/drivers/char/joystick/gamecon.c	2001-09-13 01:34:06.000000000 +0300
+++ gamecon.c	2003-09-02 01:44:41.000000000 +0300
@@ -1,5 +1,6 @@
 /*
- * $Id: gamecon.c,v 1.14 2001/04/29 22:42:14 vojtech Exp $
+ * gamecon.c, modified from version 1.14 2001/04/29 22:42:14
+ * Lets call this version 1.14p1
  *
  *  Copyright (c) 1999-2001 Vojtech Pavlik
  *
@@ -8,6 +9,14 @@
  *  	David Kuder		Nathan Hand
  *
  *  Sponsored by SuSE
+ *
+ * Modified version has less-strict timing, thus it works faster, but may
+ * not work properly with your set-up. With this hack, I can finally play
+ * Sony Playstation games with PSX-gamepad.  :-)
+ *
+ * Modifications by Tommi Saviranta  <tsaviran@cs.helsinki.fi> while the
+ * hack is inspired by work of Joe Wreschnig  <piman@debian.org>,
+ * ddrmat-0.9.tar.gz. See http://www.icculus.org/pyddr/
  */
 
 /*
@@ -213,7 +222,7 @@
  *	
  */
 
-#define GC_PSX_DELAY	60		/* 60 usec */
+#define GC_PSX_DELAY	10		/* 10 usec */
 #define GC_PSX_LENGTH	8		/* talk to the controller in bytes */
 
 #define GC_PSX_MOUSE	1		/* Mouse */
@@ -265,9 +274,9 @@
 	unsigned long flags;
 
 	parport_write_data(gc->pd->port, GC_PSX_CLOCK | GC_PSX_SELECT | GC_PSX_POWER);	/* Select pad */
-	udelay(GC_PSX_DELAY * 2);
+	udelay(GC_PSX_DELAY);
 	parport_write_data(gc->pd->port, GC_PSX_CLOCK | GC_PSX_POWER);			/* Deselect, begin command */
-	udelay(GC_PSX_DELAY * 2);
+	udelay(GC_PSX_DELAY);
 
 	__save_flags(flags);
 	__cli();
